function  WWHBookData_AddTOCEntries(P)
{
var A=P.fN("Tables","0#wp2206");
A=P.fN("Preface","1#wp32914");
var B=A.fN("Related Documentation","2#wp32941");
var C=B.fN("TIBCO Enterprise Message Service Documentation","2#wp32946");
C=B.fN("Other TIBCO Product Documentation","2#wp32985");
C=B.fN("Third Party Documentation","2#wp32996");
B=A.fN("How to Contact TIBCO Customer Support","3#wp33001");
A=P.fN("1   Introduction","4#wp1665219");
B=A.fN("Overview","5#wp2053075");
B=A.fN("Excluded Features and Restrictions","6#wp2051741");
C=B.fN("Object Serialization","6#wp2053070");
B=A.fN("Strings and Character Encodings","7#wp2074292");
B=A.fN(".NET Compact Framework (CF)","8#wp2087952");
A=P.fN("2   Programmer\u2019s Checklist","9#wp2045636");
B=A.fN("","");
C=B.fN("Install","9#wp2060468");
C=B.fN("Code","9#wp2043255");
C=B.fN("Compile","9#wp2043260");
C=B.fN("Run","9#wp2043265");
A=P.fN("3   Messages","10#wp1769957");
B=A.fN("Parts of a Message","11#wp1769981");
B=A.fN("Body Types","12#wp1816574");
B=A.fN("Headers","13#wp1839412");
B=A.fN("Properties","14#wp1839628");
C=B.fN("Setting Message Properties","14#wp1839637");
C=B.fN("EMS Properties","14#wp1839648");
C=B.fN("JMS Properties","14#wp1839765");
B=A.fN("Message Selectors","15#wp1842387");
B=A.fN("Data Type Conversion","16#wp1790507");
B=A.fN("Message","17#wp1964652");
C=B.fN("Message.Acknowledge","18#wp1830767");
C=B.fN("Message.ClearBody","19#wp1830823");
C=B.fN("Message.ClearProperties","20#wp1830840");
C=B.fN("Message.Clone","21#wp1830856");
C=B.fN("Message.GetDeliveryModeName","22#wp1830913");
C=B.fN("Message-Get Properties","23#wp1830993");
C=B.fN("Message.PropertyExists","24#wp1831049");
C=B.fN("Message-Set Properties","25#wp1831077");
C=B.fN("Message.ToString","26#wp1831125");
B=A.fN("BytesMessage","27#wp1712047");
C=B.fN("BytesMessage-Read","28#wp1853063");
C=B.fN("BytesMessage.ReadBytes","29#wp2086290");
C=B.fN("BytesMessage-Write","30#wp1748005");
C=B.fN("BytesMessage.WriteBytes","31#wp1734477");
C=B.fN("BytesMessage.Reset","32#wp1734489");
B=A.fN("MapMessage","33#wp1704643");
C=B.fN("MapMessage-Get","34#wp1760106");
C=B.fN("MapMessage.ItemExists","35#wp2086325");
C=B.fN("MapMessage-Set","36#wp1759007");
C=B.fN("MapMessage.SetBytes","37#wp2086349");
B=A.fN("ObjectMessage","38#wp1758652");
C=B.fN("ObjectMessage","39#wp2014887");
B=A.fN("StreamMessage","40#wp1705388");
C=B.fN("StreamMessage-Read","41#wp1765519");
C=B.fN("StreamMessage.ReadBytes","42#wp1765632");
C=B.fN("StreamMessage.Reset","43#wp2050944");
C=B.fN("StreamMessage-Write","44#wp1768346");
C=B.fN("StreamMessage.WriteBytes","45#wp1765770");
B=A.fN("TextMessage","46#wp1705021");
C=B.fN("TextMessage","47#wp2015044");
A=P.fN("4   Destination","48#wp1930868");
B=A.fN("Destination Overview","49#wp1965331");
B=A.fN("Destination","50#wp1930894");
B=A.fN("Queue","51#wp1931018");
C=B.fN("Queue","52#wp1931088");
B=A.fN("TemporaryQueue","53#wp1931121");
C=B.fN("TemporaryQueue.Delete","54#wp1931205");
B=A.fN("TemporaryTopic","55#wp1931220");
C=B.fN("TemporaryTopic.Delete","56#wp1931304");
B=A.fN("Topic","57#wp1931319");
C=B.fN("Topic","58#wp1931391");
A=P.fN("5   Consumer","59#wp1893831");
B=A.fN("MessageConsumer","60#wp1881603");
C=B.fN("MessageConsumer.Close","61#wp1886079");
C=B.fN("MessageConsumer.Receive","62#wp1886257");
C=B.fN("MessageConsumer.ReceiveNoWait","63#wp1886657");
B=A.fN("QueueReceiver","64#wp1882353");
B=A.fN("TopicSubscriber","65#wp1895005");
B=A.fN("EMSMessageHandler","66#wp1947163");
B=A.fN("EMSMessageEventArgs","67#wp1962266");
C=B.fN("EMSMessageEventArgs","68#wp1953438");
B=A.fN("IMessageListener","69#wp1961589");
C=B.fN("IMessageListener.OnMessage","70#wp2086394");
A=P.fN("6   Producer","71#wp1955783");
B=A.fN("MessageProducer","72#wp1895606");
C=B.fN("MessageProducer.Close","73#wp1895767");
C=B.fN("MessageProducer.Send","74#wp1895786");
B=A.fN("QueueSender","75#wp1708174");
C=B.fN("QueueSender.Send","76#wp1893032");
B=A.fN("TopicPublisher","77#wp1708289");
C=B.fN("TopicPublisher.Publish","78#wp1896486");
A=P.fN("7   Requestor","79#wp2029446");
B=A.fN("QueueRequestor","80#wp2030090");
C=B.fN("QueueRequestor","81#wp2031067");
C=B.fN("QueueRequestor.Close","82#wp2031227");
C=B.fN("QueueRequestor.Request","83#wp2051002");
B=A.fN("TopicRequestor","84#wp2036519");
C=B.fN("TopicRequestor","85#wp2036697");
C=B.fN("TopicRequestor.Close","86#wp2036740");
C=B.fN("TopicRequestor.Request","87#wp2036752");
A=P.fN("8   Connection","88#wp1708936");
B=A.fN("Connection","89#wp1709058");
C=B.fN("Connection.Close","90#wp1899612");
C=B.fN("Connection.CreateSession","91#wp2051023");
C=B.fN("Connection.Start","92#wp2051040");
C=B.fN("Connection.Stop","93#wp2051057");
B=A.fN("ConnectionMetaData","94#wp1709153");
B=A.fN("QueueConnection","95#wp1905028");
C=B.fN("QueueConnection.CreateQueueSession","96#wp1905777");
B=A.fN("TopicConnection","97#wp1709855");
C=B.fN("TopicConnection.CreateTopicSession","98#wp1905980");
B=A.fN("EMSExceptionHandler","99#wp2108849");
B=A.fN("EMSExceptionEventArgs","100#wp1956267");
C=B.fN("EMSExceptionEventArgs","101#wp1958084");
B=A.fN("IExceptionListener","102#wp1959725");
C=B.fN("IExceptionListener.OnException","103#wp1959787");
A=P.fN("9   Connection Factory","104#wp1906255");
B=A.fN("ConnectionFactory","105#wp1907463");
C=B.fN("ConnectionFactory","106#wp1907566");
C=B.fN("ConnectionFactory.CreateConnection","107#wp1907624");
B=A.fN("FactoryLoadBalanceMetric","108#wp1980208");
B=A.fN("QueueConnectionFactory","109#wp1906886");
C=B.fN("QueueConnectionFactory.CreateQueueConnection","110#wp1908082");
B=A.fN("TopicConnectionFactory","111#wp1906803");
C=B.fN("TopicConnectionFactory.CreateTopicConnection","112#wp1908158");
A=P.fN("10   Session","113#wp1909014");
B=A.fN("Session","114#wp1710808");
C=B.fN("Session.Close","115#wp1917969");
C=B.fN("Session.Commit","116#wp1918365");
C=B.fN("Session.CreateBrowser","117#wp1918491");
C=B.fN("Session.CreateBytesMessage","118#wp1919906");
C=B.fN("Session.CreateConsumer","119#wp1920776");
C=B.fN("Session.CreateDurableSubscriber","120#wp1920214");
C=B.fN("Session.CreateMapMessage","121#wp1920176");
C=B.fN("Session.CreateObjectMessage","122#wp2051089");
C=B.fN("Session.CreateProducer","123#wp1921780");
C=B.fN("Session.CreateQueue","124#wp2051107");
C=B.fN("Session.CreateStreamMessage","125#wp1922175");
C=B.fN("Session.CreateTemporaryQueue","126#wp2051125");
C=B.fN("Session.CreateTemporaryTopic","127#wp1922453");
C=B.fN("Session.CreateTextMessage","128#wp1922635");
C=B.fN("Session.CreateTopic","129#wp1922706");
C=B.fN("Session.Recover","130#wp1922911");
C=B.fN("Session.Rollback","131#wp1923578");
C=B.fN("Session.Run","132#wp1923816");
C=B.fN("Session.Unsubscribe","133#wp1923907");
B=A.fN("SessionMode","134#wp1925356");
B=A.fN("QueueSession","135#wp1926773");
B=A.fN("TopicSession","136#wp1710927");
A=P.fN("11   Queue Browser","137#wp2016198");
B=A.fN("QueueBrowser","138#wp1941630");
C=B.fN("QueueBrowser.Close","139#wp1941230");
C=B.fN("QueueBrowser.GetEnumerator","140#wp1941241");
C=B.fN("QueueBrowser.MoveNext","141#wp1941256");
C=B.fN("QueueBrowser.Reset","142#wp1941274");
A=P.fN("12   Name Server Lookup","143#wp1941903");
B=A.fN("LookupContext","144#wp1933654");
C=B.fN("LookupContext","145#wp1936231");
C=B.fN("LookupContext.AddSettings","146#wp1935993");
C=B.fN("LookupContext.Lookup","147#wp1936026");
C=B.fN("LookupContext.RemoveSettings","148#wp1935644");
A=P.fN("13   Utilities","149#wp1941993");
B=A.fN("DeliveryMode","150#wp1944598");
B=A.fN("IEMSSerialziable","151#wp2053440");
C=B.fN("IEMSSerialziable.Deserialize","152#wp2053929");
C=B.fN("IEMSSerialziable.Serialize","153#wp2053864");
B=A.fN("MessageDeliveryMode","154#wp1942901");
B=A.fN("Tibems","155#wp1698987");
C=B.fN("Tibems.CalculateMessageSize","156#wp2008220");
C=B.fN("Tibems.CreateFromBytes","157#wp2124207");
C=B.fN("Tibems.GetAllowCloseInCallback","158#wp2008499");
C=B.fN("Tibems.GetAsBytes","159#wp2009687");
C=B.fN("Tibems.GetConnectAttempts","160#wp2009985");
C=B.fN("Tibems.GetEncoding","161#wp2070104");
C=B.fN("Tibems.GetExceptionOnFTSwitch","162#wp2017935");
C=B.fN("Tibems.GetMessageEncoding","163#wp2072710");
C=B.fN("Tibems.GetMessageSize","164#wp2051163");
C=B.fN("Tibems.GetPingInterval","165#wp2019280");
C=B.fN("Tibems.GetProperty","166#wp2020213");
C=B.fN("Tibems.GetReconnectAttempts","167#wp2020819");
C=B.fN("Tibems.GetSessionDispatcherDaemon","168#wp2024190");
C=B.fN("Tibems.GetSocketReceiveBufferSize","169#wp2024226");
C=B.fN("Tibems.GetSocketSendBufferSize","170#wp2024244");
C=B.fN("Tibems.MakeWriteable","171#wp2019972");
C=B.fN("Tibems.SetAllowCloseInCallback","172#wp2051200");
C=B.fN("Tibems.SetConnectAttempts","173#wp2010119");
C=B.fN("Tibems.SetEncoding","174#wp2072109");
C=B.fN("Tibems.SetExceptionOnFTSwitch","175#wp2018983");
C=B.fN("Tibems.SetMessageEncoding","176#wp2072323");
C=B.fN("Tibems.SetPingInterval","177#wp2020169");
C=B.fN("Tibems.SetProperty","178#wp2020544");
C=B.fN("Tibems.SetReconnectAttempts","179#wp2020592");
C=B.fN("Tibems.SetSessionDispatcherDaemon","180#wp2021134");
C=B.fN("Tibems.SetSocketReceiveBufferSize","181#wp2022674");
C=B.fN("Tibems.SetSocketSendBufferSize","182#wp2022376");
A=P.fN("14   Exception","183#wp1928619");
B=A.fN("EMSException","184#wp1928710");
B=A.fN("AuthenticationException","185#wp1928842");
B=A.fN("CannotProceedException","186#wp1928857");
B=A.fN("CommunicationException","187#wp1928876");
B=A.fN("ConfigurationException","188#wp1928893");
B=A.fN("IllegalStateException","189#wp1928910");
B=A.fN("InvalidClientIDException","190#wp1928927");
B=A.fN("InvalidDestinationException","191#wp1928941");
B=A.fN("InvalidNameException","192#wp1928953");
B=A.fN("InvalidSelectorException","193#wp1928970");
B=A.fN("MessageEOFException","194#wp1928987");
B=A.fN("MessageFormatException","195#wp1929007");
B=A.fN("MessageNotReadableException","196#wp1929023");
B=A.fN("MessageNotWriteableException","197#wp1929035");
B=A.fN("NameNotFoundException","198#wp1929047");
B=A.fN("NamingException","199#wp1929059");
B=A.fN("ResourceAllocationException","200#wp1929130");
B=A.fN("SecurityException","201#wp1929142");
B=A.fN("ServiceUnavailableException","202#wp1929156");
B=A.fN("TransactionInProgressException","203#wp1929171");
B=A.fN("TransactionRolledBackException","204#wp1929185");
}
